using dodohold.core;
using CSRedis;
using System.Data;

namespace molilian.core
{
    public partial class TkLogCore
    {
        static string queue_parse_pdd_key = "queue:parse_logs:pdd";

        public static int task_insert_parse_pdd_logs(int limit, CSRedisClient redis)
        {
            int total = 0;
            using var connection = DBContext.GetOpenConnection();
            connection.Open();
            using var transaction = connection.BeginTransaction();
            try
            {
                for (int i = 0; i < limit; i++)
                {
                    var data = redis.LPop<PddDataDTO>(queue_parse_pdd_key);
                    if (data == null) break;


                    if (_test_oaid.Equals(data.oaid) ||
                         data.ip.Contains("127.0.0"))
                    {
                        save_pdd_parse_logs(data, "pdd_parse_logs_test", connection, transaction);
                    }
                    else
                    {
                        save_pdd_parse_logs(data, "pdd_parse_logs", connection, transaction);
                        if (data.success)
                        {
                            save_pdd_parse_logs(data, "pdd_parse_logs_success", connection, transaction);
                        }
                    }
                    total++;
                }
                transaction.Commit();
            }
            catch (Exception ex)
            {
                transaction.Rollback();
                new LoggerLibrary("TkLogCore_error", "task_insert_parse_pdd_logs")
                      .Info(ex.Message, ex.StackTrace)
                      .SaveAsync();
                throw;
            }
            finally
            {
                connection.Close();
            }
            return total;
        }


        public static async Task ParseLogAsync(PddDataDTO response)
        {
            try
            {
                var ts = DateTime.Now - response.create_time;
                response.elapsedTime = (int)ts.TotalMilliseconds;
                _ = RedisHelper.RPushAsync(queue_parse_pdd_key, response);


#if DEBUG
                for (int i = 0; i < 100; i++)
                {
                    var data = RedisHelper.LPop<PddDataDTO>(queue_parse_pdd_key);
                    if (data == null) break;


                    if (data.ip.Contains("127.0.0"))
                    {
                        save_pdd_parse_logs(data, "pdd_parse_logs_test", null, null);
                    }
                    else
                    {
                        save_pdd_parse_logs(data, "pdd_parse_logs", null, null);
                        if (data.success)
                        {
                            save_pdd_parse_logs(data, "pdd_parse_logs_success", null, null);
                        }
                    }
                }

#endif

                if (!response.ip.Contains("127.0.0"))
                {
                    saveParseCache(response.channel.ToString(), response.accountId,
                        response.accountName, response.success, response.message, response.reason,
                        response.deeplink_url);
                }

                if (response.success || response.message.Equals("转链失败"))
                {
                    PddPoolCore.CallsIncrBy(response.accountId);
                }

                if (response.reason.Equals("您的调用次数过高"))
                {
                    PddPoolCore.TempSuspend(response.accountId);
                }

                if (response.success) saveClientRequestTotal(response.channel, response.ip, response.oaid);

                if (!response.success && ("nologin".Equals(response.reason) ||
                    "方法不存在".Equals(response.reason) ||
                    "未登录".Equals(response.reason)))
                {
                    await Task.Run(() =>
                    {
                        PddPoolCore.Disabled(response.accountId, response.accountName, $"{response.rawContent}\n{response.rawContent2}");
                    });
                }
                if ("没有匹配账号".Equals(response.reason))
                {
                    PddPoolCore.AccountExhausted();
                }
            }
            catch (Exception ex) { }
        }
        private static int save_pdd_parse_logs(PddDataDTO data, string tablename, IDbConnection connection, IDbTransaction transaction)
        {
            return new DBContext.Table(connection, tablename)
                .Add("end_point", data.end_point)
                .Add("channel", (int)data.channel)
                .Add("accountId", data.accountId)
                .Add("accountName", data.accountName)
                .Add("rawContent", data.rawContent)
                .Add("rawContent2", data.rawContent2)
                .Add("success", data.success)
                .Add("message", data.message)
                .Add("reason", data.reason)
                .Add("content", data.content)
                .Add("itemId", data.itemId)
                .Add("itemName", data.itemName)
                .Add("pic", data.pic)
                .Add("couponAmount", data.couponAmount)
                .Add("promotionPrice", data.promotionPrice)
                .Add("taoToken", data.taoToken)
                .Add("shortLinkurl", data.shortLinkurl)
                .Add("deeplink_url", data.deeplink_url)
                .Add("elapsedTime", data.elapsedTime)
                .Add("elapsedTime2", data.elapsedTime2)
                .Add("elapsedTime3", data.elapsedTime3)
                .Add("subCode", data.subCode)
                .Add("ip", data.ip)
                .Add("oaid", data.oaid)
                .Add("create_time", data.create_time)
                .Create(DBContext.InsertType.NORMAL, transaction);

        }

    }

}
